searchNodes=[{"doc":"A Neo4j driver for Elixir providing many useful features: using the Bolt protocol, the Elixir implementation - the Neo4j&#39;s newest network protocol, designed for high-performance; latest Bolt versions, are supported. Can connect to a standalone Neo4j server (:direct mode) or to a Neo4j causal cluster, using the bolt+routing or the newer neo4j schemes; connecting in :routing mode. Provides the user with the ability to create and manage distinct ad-hoc role-based connections to one or more Neo4j servers/databases Supports transactions, simple and complex Cypher queries with or w/o parameters Multi-tenancy Supports Neo4j versions: 3.0.x/3.1.x/3.2.x/3.4.x/3.5.x To start, add the :bolt_sips dependency to you project, run mix do deps.get, compile on it and then you can quickly start experimenting with Neo4j from the convenience of your IEx shell. Example: iex» {:ok, _neo} = Bolt.Sips.start_link(url: &quot;bolt://neo4j:test@localhost&quot;) {:ok, #PID&lt;0.250.0&gt;} iex» conn = Bolt.Sips.conn() #PID&lt;0.256.0&gt; iex» Bolt.Sips.query!(conn, &quot;RETURN 1 as n&quot;) %Bolt.Sips.Response{ records: [[1]], results: [%{&quot;n&quot; =&gt; 1}] } the example above presumes that you have a Neo4j server available locally, using the Bolt protocol and requiring authentication.","ref":"Bolt.Sips.html","title":"Bolt.Sips","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Bolt.Sips.html#child_spec/1","title":"Bolt.Sips.child_spec/1","type":"function"},{"doc":"Returns a pool name which can be used to acquire a connection from a pool of servers responsible with a specific type of operations: read, write and route, or all of the above: &quot;direct&quot;","ref":"Bolt.Sips.html#conn/2","title":"Bolt.Sips.conn/2","type":"function"},{"doc":"peek into the main Router state, and return the internal state controlling the connections to the server/server. Mostly for internal use or for helping driver developers.","ref":"Bolt.Sips.html#info/0","title":"Bolt.Sips.info/0","type":"function"},{"doc":"sends the query (and its parameters) to the server and returns {:ok, Response.t()} or {:error, Error} otherwise","ref":"Bolt.Sips.html#query/2","title":"Bolt.Sips.query/2","type":"function"},{"doc":"send a query and an associated map of parameters. Returns the server response or an error","ref":"Bolt.Sips.html#query/3","title":"Bolt.Sips.query/3","type":"function"},{"doc":"send a query and an associated map of parameters with options. Returns the server response or an error The opts keyword list will be passed to DbConnection.execute/4. By default, the query will timeout after 15_000 milliseconds, this may be overriden by setting the timeout option in opts.","ref":"Bolt.Sips.html#query/4","title":"Bolt.Sips.query/4","type":"function"},{"doc":"The same as query/2 but raises a Exception if it fails. Returns the server response otherwise.","ref":"Bolt.Sips.html#query!/2","title":"Bolt.Sips.query!/2","type":"function"},{"doc":"The same as query/3 but raises a Exception if it fails.","ref":"Bolt.Sips.html#query!/3","title":"Bolt.Sips.query!/3","type":"function"},{"doc":"The same as query/4 but raises a Exception if it fails.","ref":"Bolt.Sips.html#query!/4","title":"Bolt.Sips.query!/4","type":"function"},{"doc":"the registry name used across the various driver components","ref":"Bolt.Sips.html#registry_name/0","title":"Bolt.Sips.registry_name/0","type":"function"},{"doc":"Rollback a database transaction and release lock on connection. When inside of a transaction/3 call does a non-local return, using a throw/1 to cause the transaction to enter a failed state and the transaction/3 call returns {:error, reason}. If transaction/3 calls are nested the connection is marked as failed until the outermost transaction call does the database rollback. Example {:error, :oops} = Bolt.Sips.transaction(pool, fn(conn) -&gt; Bolt.Sips.rollback(conn, :oops) end)","ref":"Bolt.Sips.html#rollback/2","title":"Bolt.Sips.rollback/2","type":"function"},{"doc":"extract the routing table from the router","ref":"Bolt.Sips.html#routing_table/1","title":"Bolt.Sips.routing_table/1","type":"function"},{"doc":"Start or add a new Neo4j connection Options: :url- a full url to pointing to a running Neo4j server. Please remember you must specify the scheme used to connect to the server. Valid schemes:bolt,bolt+routingandneo4j - the last two being used for connecting to a Neo4j causal cluster. :pool_size - the size of the connection pool. Default: 15 :timeout - a connection timeout value defined in milliseconds. Default: 15_000 :ssl-true, if the connection must be encrypted. Default:false :prefix- used for differentiating between multiple connections available in the same app. Default::default Example of valid configurations (i.e. defined in config/dev.exs) and usage: This is the most basic configuration: config :bolt_sips, Bolt, url: &quot;bolt://localhost:7687&quot; and if you need to connect to remote servers: config :bolt_sips, Bolt, url: &quot;bolt://Bilbo:Baggins@hobby-hobbits.dbs.graphenedb.com:24786&quot;, ssl: true, timeout: 15_000, Example with a configuration defined in the config/dev.exs: opts = Application.get_env(:bolt_sips, Bolt) {:ok, pid} = Bolt.Sips.start_link(opts) Bolt.Sips.query!(pid, &quot;CREATE (a:Person {name:&#39;Bob&#39;})&quot;) Bolt.Sips.query!(pid, &quot;MATCH (a:Person) RETURN a.name AS name&quot;) |&gt; Enum.map(&amp;(&amp;1[&quot;name&quot;])) Or defining an ad-hoc configuration: Example with a configuration defined in the config/dev.exs: {:ok, _neo} = Bolt.Sips.start_link(url: &quot;bolt://neo4j:test@localhost&quot;) conn = Bolt.Sips.conn() Bolt.Sips.query!(conn, &quot;return 1 as n&quot;)","ref":"Bolt.Sips.html#start_link/1","title":"Bolt.Sips.start_link/1","type":"function"},{"doc":"terminate a pool of connections with the role specified","ref":"Bolt.Sips.html#terminate_connections/1","title":"Bolt.Sips.terminate_connections/1","type":"function"},{"doc":"Example: setup do {:ok, [main_conn: Bolt.Sips.conn()]} end test &quot;execute statements in transaction&quot;, %{main_conn: main_conn} do Bolt.Sips.transaction(main_conn, fn conn -&gt; book = Bolt.Sips.query!(conn, &quot;CREATE (b:Book {title: &quot;The Game Of Trolls&quot;}) return b&quot;) |&gt; Response.first() assert %{&quot;b&quot; =&gt; g_o_t} = book assert g_o_t.properties[&quot;title&quot;] == &quot;The Game Of Trolls&quot; Bolt.Sips.rollback(conn, :changed_my_mind) end) books = Bolt.Sips.query!(main_conn, &quot;MATCH (b:Book {title: &quot;The Game Of Trolls&quot;}) return b&quot;) assert Enum.count(books) == 0 end","ref":"Bolt.Sips.html#transaction/3","title":"Bolt.Sips.transaction/3","type":"function"},{"doc":"","ref":"Bolt.Sips.html#t:conn/0","title":"Bolt.Sips.conn/0","type":"type"},{"doc":"","ref":"Bolt.Sips.html#t:transaction/0","title":"Bolt.Sips.transaction/0","type":"type"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html","title":"Bolt.Sips.ConnectionSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Bolt.Sips.ConnectionSupervisor.html#child_spec/1","title":"Bolt.Sips.ConnectionSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#connections/0","title":"Bolt.Sips.ConnectionSupervisor.connections/0","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#find_connection/1","title":"Bolt.Sips.ConnectionSupervisor.find_connection/1","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#find_connection/3","title":"Bolt.Sips.ConnectionSupervisor.find_connection/3","type":"function"},{"doc":"the resulting connection name i.e. &quot;write@localhost:7687&quot; will be used to spawn new DBConnection processes, and for finding available connections","ref":"Bolt.Sips.ConnectionSupervisor.html#start_child/3","title":"Bolt.Sips.ConnectionSupervisor.start_child/3","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#start_link/1","title":"Bolt.Sips.ConnectionSupervisor.start_link/1","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#terminate_connection/3","title":"Bolt.Sips.ConnectionSupervisor.terminate_connection/3","type":"function"},{"doc":"","ref":"Bolt.Sips.ConnectionSupervisor.html#via_tuple/1","title":"Bolt.Sips.ConnectionSupervisor.via_tuple/1","type":"function"},{"doc":"represents an error message","ref":"Bolt.Sips.Error.html","title":"Bolt.Sips.Error","type":"module"},{"doc":"","ref":"Bolt.Sips.Error.html#new/1","title":"Bolt.Sips.Error.new/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Error.html#t:t/0","title":"Bolt.Sips.Error.t/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Internals.BoltProtocolV3.html","title":"Bolt.Sips.Internals.BoltProtocolV3","type":"module"},{"doc":"Implementation of Bolt&#39;s BEGIN. It opens a transaction. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Example iex&gt; BoltProtocolV3.begin(:gen_tcp, port, 3, []) {:ok, metadata}","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#begin/5","title":"Bolt.Sips.Internals.BoltProtocolV3.begin/5","type":"function"},{"doc":"Implementation of Bolt&#39;s COMMIT. It commits the open transaction. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Example iex&gt; BoltProtocolV3.commit(:gen_tcp, port, 3, []) :ok","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#commit/4","title":"Bolt.Sips.Internals.BoltProtocolV3.commit/4","type":"function"},{"doc":"Implementation of Bolt&#39;s RUN. It closes the connection. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Examples iex&gt; Bolt.Sips.Internals.BoltProtocolV3.goodbye(:gen_tcp, port, 3) :ok iex&gt; Bolt.Sips.Internals.BoltProtocolV3.goodbye(:gen_tcp, port, 3) :ok","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#goodbye/3","title":"Bolt.Sips.Internals.BoltProtocolV3.goodbye/3","type":"function"},{"doc":"Implementation of Bolt&#39;s HELLO. It initialises the connection. Expects a transport module (i.e. gen_tcp) and a Port. Accepts authorisation params in the form of {username, password}. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Examples iex&gt; Bolt.Sips.Internals.BoltProtocolV3.hello(:gen_tcp, port, 3, {}, []) {:ok, info} iex&gt; Bolt.Sips.Internals.BoltProtocolV3.hello(:gen_tcp, port, 3, {&quot;username&quot;, &quot;password&quot;}, []) {:ok, info}","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#hello/5","title":"Bolt.Sips.Internals.BoltProtocolV3.hello/5","type":"function"},{"doc":"Implementation of Bolt&#39;s ROLLBACK. It rollbacks the open transaction. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Example iex&gt; BoltProtocolV3.rollback(:gen_tcp, port, 3, []) :ok","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#rollback/4","title":"Bolt.Sips.Internals.BoltProtocolV3.rollback/4","type":"function"},{"doc":"Implementation of Bolt&#39;s RUN. It passes a statement for execution on the server. Note that this message doesn&#39;t return the statement result. For this purpose, use PULL_ALL. In bolt &gt;= 3, run has an additional paramters; metadata Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Example iex&gt; BoltProtocolV1.run(:gen_tcp, port, 1, &quot;RETURN {num} AS num&quot;, %{num: 5}, %{}, []) {:ok, {:success, %{&quot;fields&quot; =&gt; [&quot;num&quot;]}}}","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#run/7","title":"Bolt.Sips.Internals.BoltProtocolV3.run/7","type":"function"},{"doc":"Runs a statement (most likely Cypher statement) and returns a list of the records and a summary (Act as as a RUN + PULL_ALL). Records are represented using PackStream&#39;s record data type. Their Elixir representation is a Keyword with the indexes :sig and :fields. Options See &quot;Shared options&quot; in Bolt.Sips.Internals.BoltProtocolHelper documentation. Examples iex&gt; Bolt.Sips.Internals.BoltProtocol.run_statement(:gen_tcp, port, 1, &quot;MATCH (n) RETURN n&quot;) [ {:success, %{&quot;fields&quot; =&gt; [&quot;n&quot;]}}, {:record, [sig: 1, fields: [1, &quot;Example&quot;, &quot;Labels&quot;, %{&quot;some_attribute&quot; =&gt; &quot;some_value&quot;}]]}, {:success, %{&quot;type&quot; =&gt; &quot;r&quot;}} ]","ref":"Bolt.Sips.Internals.BoltProtocolV3.html#run_statement/7","title":"Bolt.Sips.Internals.BoltProtocolV3.run_statement/7","type":"function"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.DecoderImplV1.html","title":"Bolt.Sips.Internals.PackStream.DecoderImplV1","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.DecoderImplV2.html","title":"Bolt.Sips.Internals.PackStream.DecoderImplV2","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.DecoderUtils.html","title":"Bolt.Sips.Internals.PackStream.DecoderUtils","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.DecoderV3.html","title":"Bolt.Sips.Internals.PackStream.DecoderV3","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.DecoderV3.html#decode/2","title":"Bolt.Sips.Internals.PackStream.DecoderV3.decode/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.EncoderV3.html","title":"Bolt.Sips.Internals.PackStream.EncoderV3","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.Message.EncoderV2.html","title":"Bolt.Sips.Internals.PackStream.Message.EncoderV2","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.Message.EncoderV2.html#encode/2","title":"Bolt.Sips.Internals.PackStream.Message.EncoderV2.encode/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.Utils.html","title":"Bolt.Sips.Internals.PackStream.Utils","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.V1.html","title":"Bolt.Sips.Internals.PackStream.V1","type":"module"},{"doc":"","ref":"Bolt.Sips.Internals.PackStream.V2.html","title":"Bolt.Sips.Internals.PackStream.V2","type":"module"},{"doc":"a simple load balancer used for selecting a server address from a map. The address is selected based on how many hits has; least reused url.","ref":"Bolt.Sips.LoadBalancer.html","title":"Bolt.Sips.LoadBalancer","type":"module"},{"doc":"sort by total number of hits and return the least reused url ## Examples iex&gt; least_reused_url(%{&quot;url1&quot; =&gt; 10, &quot;url2&quot; =&gt; 5}) {:ok, &quot;url2&quot;} iex&gt; least_reused_url(%{}) {:error, :not_found}","ref":"Bolt.Sips.LoadBalancer.html#least_reused_url/1","title":"Bolt.Sips.LoadBalancer.least_reused_url/1","type":"function"},{"doc":"Provides a simple Query DSL. You can run simple Cypher queries with or w/o parameters, for example: {:ok, row} = Bolt.Sips.query(conn, &quot;match (n:Person {bolt_sips: true}) return n.name as Name limit 5&quot;) assert List.first(row)[&quot;Name&quot;] == &quot;Patrick Rothfuss&quot; Or more complex ones: cypher = &quot;&quot;&quot; MATCH (p:Person {bolt_sips: true}) RETURN p, p.name AS name, upper(p.name) as NAME, coalesce(p.nickname,&quot;n/a&quot;) AS nickname, { name: p.name, label:head(labels(p))} AS person &quot;&quot;&quot; {:ok, r} = Bolt.Sips.query(conn, cypher) As you can see, you can organize your longer queries using the Elixir multiple line conventions, for readability. And there is one more trick, you can use for more complex Cypher commands: use ; as a transactional separator. For example, say you want to clean up the test database before creating some tests entities. You can do that like this: cypher = &quot;&quot;&quot; MATCH (n {bolt_sips: true}) OPTIONAL MATCH (n)-[r]-() DELETE n,r; CREATE (BoltSips:BoltSips {title:&#39;Elixir sipping from Neo4j, using Bolt&#39;, released:2016, license:&#39;MIT&#39;, bolt_sips: true}) CREATE (TNOTW:Book {title:&#39;The Name of the Wind&#39;, released:2007, genre:&#39;fantasy&#39;, bolt_sips: true}) CREATE (Patrick:Person {name:&#39;Patrick Rothfuss&#39;, bolt_sips: true}) CREATE (Kvothe:Person {name:&#39;Kote&#39;, bolt_sips: true}) CREATE (Denna:Person {name:&#39;Denna&#39;, bolt_sips: true}) CREATE (Chandrian:Deamon {name:&#39;Chandrian&#39;, bolt_sips: true}) CREATE (Kvothe)-[:ACTED_IN {roles:[&#39;sword fighter&#39;, &#39;magician&#39;, &#39;musician&#39;]}]-&gt;(TNOTW), (Denna)-[:ACTED_IN {roles:[&#39;many talents&#39;]}]-&gt;(TNOTW), (Chandrian)-[:ACTED_IN {roles:[&#39;killer&#39;]}]-&gt;(TNOTW), (Patrick)-[:WROTE]-&gt;(TNOTW) &quot;&quot;&quot; assert {:ok, _r} = Bolt.Sips.query(conn, cypher) In the example above, this command: MATCH (n {bolt_sips: true}) OPTIONAL MATCH (n)-[r]-() DELETE n,r; will be executed in a distinct transaction, before all the other queries See the various tests, or more examples and implementation details.","ref":"Bolt.Sips.Query.html","title":"Bolt.Sips.Query","type":"module"},{"doc":"","ref":"Bolt.Sips.Query.html#query/2","title":"Bolt.Sips.Query.query/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Query.html#query/4","title":"Bolt.Sips.Query.query/4","type":"function"},{"doc":"","ref":"Bolt.Sips.Query.html#query!/2","title":"Bolt.Sips.Query.query!/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Query.html#query!/4","title":"Bolt.Sips.Query.query!/4","type":"function"},{"doc":"Support for transforming a Bolt response to a list of Bolt.Sips.Types or arbitrary values. A Bolt.Sips.Response is used for mapping any response received from a Neo4j server into a an Elixir struct. You&#39;ll interact with this module every time you&#39;re needing to get and manipulate the data resulting from your queries. For example, a simple Cypher query like this: Bolt.Sips.query(Bolt.Sips.conn(), &quot;RETURN [10,11,21] AS arr&quot;) will return: {:ok, %Bolt.Sips.Response{ bookmark: &quot;neo4j:bookmark:v1:tx21868&quot;, fields: [&quot;arr&quot;], notifications: [], plan: nil, profile: nil, records: [[[10, 11, 21]]], results: [%{&quot;arr&quot; =&gt; [10, 11, 21]}], stats: [], type: &quot;r&quot; }} and while you have now access to the full data returned by Neo4j, most of the times you&#39;ll just want the results: iex» %Bolt.Sips.Response{results: results} = Bolt.Sips.query!(Bolt.Sips.conn(), &quot;RETURN [10,11,21] AS arr&quot;) iex» results [%{&quot;arr&quot; =&gt; [10, 11, 21]}] More complex queries, i.e.: MATCH p=({name:&#39;Alice&#39;})-[r:KNOWS]-&gt;({name:&#39;Bob&#39;}) RETURN r will return results like this: [%{&quot;r&quot; =&gt; %Bolt.Sips.Types.Relationship{end: 647, id: 495, properties: %{}, start: 646, type: &quot;KNOWS&quot;}}] Note: the Path has also functionality for &quot;drawing&quot; a graph, from a given node-relationship path Our Bolt.Sips.Response is implementing Elixir&#39;s Enumerable Protocol, to help you accessing the results. Hence something like this, is possible: iex» Bolt.Sips.query!(Bolt.Sips.conn(), &quot;RETURN [10,11,21] AS arr&quot;) |&gt; ...» Enum.reduce(0, &amp;(Enum.sum(&amp;1[&quot;arr&quot;]) + &amp;2)) 42 an overly complicated example, but you get the point?! :) You can also quickly get the first of the results, returned by Neo4j. Example: iex» Bolt.Sips.query!(Bolt.Sips.conn(), &quot;UNWIND range(1, 10) AS n RETURN n&quot;) |&gt; ...» Bolt.Sips.Response.first() %{&quot;n&quot; =&gt; 1}","ref":"Bolt.Sips.Response.html","title":"Bolt.Sips.Response","type":"module"},{"doc":"","ref":"Bolt.Sips.Response.html#fetch/2","title":"Bolt.Sips.Response.fetch/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Response.html#fetch!/2","title":"Bolt.Sips.Response.fetch!/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Response.html#first/1","title":"Bolt.Sips.Response.first/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Response.html#transform/2","title":"Bolt.Sips.Response.transform/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Response.html#t:acc/0","title":"Bolt.Sips.Response.acc/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Response.html#t:element/0","title":"Bolt.Sips.Response.element/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Response.html#t:key/0","title":"Bolt.Sips.Response.key/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Response.html#t:t/0","title":"Bolt.Sips.Response.t/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Response.html#t:value/0","title":"Bolt.Sips.Response.value/0","type":"type"},{"doc":"This module provides functions to encode a query result or data containing Bolt.Sips.Types into various format. For now, only JSON is supported. Encoding is handled by protocols to allow override if a specific implemention is required. See targeted protocol documentation for more information","ref":"Bolt.Sips.ResponseEncoder.html","title":"Bolt.Sips.ResponseEncoder","type":"module"},{"doc":"Encode the data in json format. This is done is 2 steps: first, the data is converted into a jsonable format the result is encoded in json via Jason Both of these steps are overridable, see: for step 1: Bolt.Sips.ResponseEncoder.Json for step 2 (depending of your preferred library): Bolt.Sips.ResponseEncoder.Json.Jason Bolt.Sips.ResponseEncoder.Json.Poison Example iex&gt; data = %{&quot;t1&quot; =&gt; %Bolt.Sips.Types.Node{ ...&gt; id: 69, ...&gt; labels: [&quot;Test&quot;], ...&gt; properties: %{ ...&gt; &quot;created&quot; =&gt; %Bolt.Sips.Types.DateTimeWithTZOffset{ ...&gt; naive_datetime: ~N[2016-05-24 13:26:08.543], ...&gt; timezone_offset: 7200 ...&gt; }, ...&gt; &quot;uuid&quot; =&gt; 12345 ...&gt; } ...&gt; } ...&gt; } iex&gt; Bolt.Sips.ResponseEncoder.encode(data, :json) {:ok, ~S|{&quot;t1&quot;:{&quot;id&quot;:69,&quot;labels&quot;:[&quot;Test&quot;],&quot;properties&quot;:{&quot;created&quot;:&quot;2016-05-24T13:26:08.543+02:00&quot;,&quot;uuid&quot;:12345}}}|} iex&gt; Bolt.Sips.ResponseEncoder.encode(&quot;\\xFF&quot;, :json) {:error, %Jason.EncodeError{message: &quot;invalid byte 0xFF in &lt;&lt;255&gt;&gt;&quot;}}","ref":"Bolt.Sips.ResponseEncoder.html#encode/2","title":"Bolt.Sips.ResponseEncoder.encode/2","type":"function"},{"doc":"Encode the data in json format. Similar to encode/1 except it will unwrap the error tuple and raise in case of errors. Example iex&gt; data = %{&quot;t1&quot; =&gt; %Bolt.Sips.Types.Node{ ...&gt; id: 69, ...&gt; labels: [&quot;Test&quot;], ...&gt; properties: %{ ...&gt; &quot;created&quot; =&gt; %Bolt.Sips.Types.DateTimeWithTZOffset{ ...&gt; naive_datetime: ~N[2016-05-24 13:26:08.543], ...&gt; timezone_offset: 7200 ...&gt; }, ...&gt; &quot;uuid&quot; =&gt; 12345 ...&gt; } ...&gt; } ...&gt; } iex&gt; Bolt.Sips.ResponseEncoder.encode!(data, :json) ~S|{&quot;t1&quot;:{&quot;id&quot;:69,&quot;labels&quot;:[&quot;Test&quot;],&quot;properties&quot;:{&quot;created&quot;:&quot;2016-05-24T13:26:08.543+02:00&quot;,&quot;uuid&quot;:12345}}}| iex&gt; Bolt.Sips.ResponseEncoder.encode!(&quot;\\xFF&quot;, :json) ** (Jason.EncodeError) invalid byte 0xFF in &lt;&lt;255&gt;&gt;","ref":"Bolt.Sips.ResponseEncoder.html#encode!/2","title":"Bolt.Sips.ResponseEncoder.encode!/2","type":"function"},{"doc":"Protocol controlling how a value is made jsonable. Its only purpose is to convert Bolt Sips specific structures into elixir buit-in types which can be encoed in json by Jason. Deriving If the provided default implementation don&#39;t fit your need, you can override with your own implementation. Example Let&#39;s assume that you don&#39;t want Node&#39;s id available as they are Neo4j&#39;s ones and are not reliable because of id reuse and you want to have you own uuid in place. Instead of: { id: 0, labels: [&quot;TestNode&quot;], properties: { uuid: &quot;837806a7-6c37-4630-9f6c-9aa7ad0129ed&quot; value: &quot;my node&quot; } } you want: { uuid: &quot;837806a7-6c37-4630-9f6c-9aa7ad0129ed&quot;, labels: [&quot;TestNode&quot;], properties: { value: &quot;my node&quot; } } You can achieve that with the following implementation: defimpl Bolt.Sips.ResponseEncoder.Json, for: Bolt.Sips.Types.Node do def encode(node) do new_props = Map.drop(node.properties, :uuid) node |&gt; Map.from_struct() |&gt; Map.put(:uuid, node.properties.uuid) |&gt; Map.put(:properties, new_props) end end It is also possible to provide implementation that returns structs or updated Bolt.Sips.Types, the use of a final Bolt.Sips.ResponseEncoder.Json.encode() will ensure that these values will be converted to jsonable ones.","ref":"Bolt.Sips.ResponseEncoder.Json.html","title":"Bolt.Sips.ResponseEncoder.Json","type":"protocol"},{"doc":"Convert a value in a jsonable format","ref":"Bolt.Sips.ResponseEncoder.Json.html#encode/1","title":"Bolt.Sips.ResponseEncoder.Json.encode/1","type":"function"},{"doc":"","ref":"Bolt.Sips.ResponseEncoder.Json.html#t:t/0","title":"Bolt.Sips.ResponseEncoder.Json.t/0","type":"type"},{"doc":"A default implementation for Jason encoding library. More info about Jason: https://hex.pm/packages/jason Allow this usage: conn = Bolt.Sips.conn() {:ok, res} = Bolt.Sips.query(conn, &quot;MATCH (t:TestNode) RETURN t&quot;) Jason.encode!(res) Default implementation can be overriden by providing your own implementation. More info about implementation: https://hexdocs.pm/jason/readme.html#differences-to-poison Note: In order to benefit from Bolt.Sips.ResponseEncoder implementation, use Bolt.Sips.ResponseEncoder.Json.encode and pass the result to the Jason encoding functions.","ref":"Bolt.Sips.ResponseEncoder.Json.Jason.html","title":"Bolt.Sips.ResponseEncoder.Json.Jason","type":"module"},{"doc":"A default implementation for Poison encoding library. More info about poison here: https://hex.pm/packages/poison Allow this usage: conn = Bolt.Sips.conn() {:ok, res} = Bolt.Sips.query(conn, &quot;MATCH (t:TestNode) RETURN t&quot;) Poison.encode!(res) Default implementation can be overriden by providing your own implementation. More info about implementation: https://hexdocs.pm/poison/Poison.html#module-encoder Note: In order to benefit from Bolt.Sips.ResponseEncoder implementation, use Bolt.Sips.ResponseEncoder.Json.encode and pass the result to the Poison encoding functions.","ref":"Bolt.Sips.ResponseEncoder.Json.Poison.html","title":"Bolt.Sips.ResponseEncoder.Json.Poison","type":"module"},{"doc":"This &quot;driver&quot; works in tandem with Neo4j&#39;s Causal Clustering feature by directing read and write behaviour to appropriate cluster members","ref":"Bolt.Sips.Router.html","title":"Bolt.Sips.Router","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Bolt.Sips.Router.html#child_spec/1","title":"Bolt.Sips.Router.child_spec/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#configure/1","title":"Bolt.Sips.Router.configure/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#get_connection/2","title":"Bolt.Sips.Router.get_connection/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#info/0","title":"Bolt.Sips.Router.info/0","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#merge_connections_maps/3","title":"Bolt.Sips.Router.merge_connections_maps/3","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#routing_table/1","title":"Bolt.Sips.Router.routing_table/1","type":"function"},{"doc":"start a new (DB)Connection process, supervised registered under a name following this convention: &quot;role@hostname:port&quot;, the role, hostname and the port are collected from the user&#39;s configuration: opts. The role parameter is ignored when the routing_table parameter represents a neo4j map containing the definition for a neo4j cluster! It defaults to: :direct, when not specified!","ref":"Bolt.Sips.Router.html#start_connections/2","title":"Bolt.Sips.Router.start_connections/2","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#start_link/1","title":"Bolt.Sips.Router.start_link/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Router.html#terminate_connections/2","title":"Bolt.Sips.Router.terminate_connections/2","type":"function"},{"doc":"todo: this is work in progress and will be used for defining the state of the Router (Gen)Server","ref":"Bolt.Sips.Router.State.html","title":"Bolt.Sips.Router.State","type":"module"},{"doc":"","ref":"Bolt.Sips.Router.State.html#t:role/0","title":"Bolt.Sips.Router.State.role/0","type":"type"},{"doc":"","ref":"Bolt.Sips.Router.State.html#t:t/0","title":"Bolt.Sips.Router.State.t/0","type":"type"},{"doc":"representing the routing table elements There are a couple of ways to get the routing table from the server, for recent Neo4j servers, and with the latest version of Bolt.Sips, you could use this query: Bolt.Sips.query!(Bolt.Sips.conn, &quot;call dbms.cluster.routing.getRoutingTable({props})&quot;, %{props: %{}}) [ %{ &quot;servers&quot; =&gt; [ %{&quot;addresses&quot; =&gt; [&quot;localhost:7687&quot;], &quot;role&quot; =&gt; &quot;WRITE&quot;}, %{&quot;addresses&quot; =&gt; [&quot;localhost:7689&quot;, &quot;localhost:7688&quot;], &quot;role&quot; =&gt; &quot;READ&quot;}, %{ &quot;addresses&quot; =&gt; [&quot;localhost:7688&quot;, &quot;localhost:7689&quot;, &quot;localhost:7687&quot;], &quot;role&quot; =&gt; &quot;ROUTE&quot; } ], &quot;ttl&quot; =&gt; 300 } ]","ref":"Bolt.Sips.Routing.RoutingTable.html","title":"Bolt.Sips.Routing.RoutingTable","type":"module"},{"doc":"","ref":"Bolt.Sips.Routing.RoutingTable.html#parse/1","title":"Bolt.Sips.Routing.RoutingTable.parse/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Routing.RoutingTable.html#parse_ttl/1","title":"Bolt.Sips.Routing.RoutingTable.parse_ttl/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Routing.RoutingTable.html#t:t/0","title":"Bolt.Sips.Routing.RoutingTable.t/0","type":"type"},{"doc":"A default socket interface used to communicate to a Neo4j instance. Any other socket implementing the same interface can be used in place of this one. Actually, this module doesn&#39;t implement the interface on its own, it delegates calls to the gen_tcp (http://erlang.org/doc/man/gen_tcp.html) and inet (http://erlang.org/doc/man/inet.html) modules. Any of these modules doesn&#39;t fully implement the required interface, hence, both of them must be used.","ref":"Bolt.Sips.Socket.html","title":"Bolt.Sips.Socket","type":"module"},{"doc":"Delegates to :inet.close/1","ref":"Bolt.Sips.Socket.html#close/1","title":"Bolt.Sips.Socket.close/1","type":"function"},{"doc":"Delegates to :gen_tcp.connect/4","ref":"Bolt.Sips.Socket.html#connect/4","title":"Bolt.Sips.Socket.connect/4","type":"function"},{"doc":"Delegates to :gen_tcp.recv/2","ref":"Bolt.Sips.Socket.html#recv/2","title":"Bolt.Sips.Socket.recv/2","type":"function"},{"doc":"Delegates to :gen_tcp.recv/3","ref":"Bolt.Sips.Socket.html#recv/3","title":"Bolt.Sips.Socket.recv/3","type":"function"},{"doc":"Delegates to :gen_tcp.send/2","ref":"Bolt.Sips.Socket.html#send/2","title":"Bolt.Sips.Socket.send/2","type":"function"},{"doc":"Delegates to :inet.setopts/2","ref":"Bolt.Sips.Socket.html#setopts/2","title":"Bolt.Sips.Socket.setopts/2","type":"function"},{"doc":"Basic support for representing nodes, relationships and paths belonging to a Neo4j graph database. Four supported types of entities: Node Relationship UnboundRelationship Path More details, about the Bolt protocol, here: https://github.com/boltprotocol/boltprotocol/blob/master/README.md Additionally, since bolt V2, new types appears: spatial and temporal Those are not documented in bolt protocol, but neo4j documentation can be found here: https://neo4j.com/docs/cypher-manual/current/syntax/temporal/ https://neo4j.com/docs/cypher-manual/current/syntax/spatial/ To work with temporal types, the following Elixir structs are available: Time, DateTime, NaiveDateTime Calendar.DateTime to work with timezone (as string) TimeWithTZOffset, DateTimeWithTZOffset to work with (date)time and timezone offset(as integer) Duration For spatial types, you only need Point struct as it covers: 2D point (cartesian or geographic) 3D point (cartesian or geographic)","ref":"Bolt.Sips.Types.html","title":"Bolt.Sips.Types","type":"module"},{"doc":"Manage a Time and its time zone offset. This temporal types hs been added in bolt v2","ref":"Bolt.Sips.Types.DateTimeWithTZOffset.html","title":"Bolt.Sips.Types.DateTimeWithTZOffset","type":"module"},{"doc":"Create a valid DateTimeWithTZOffset from a NaiveDateTime and offset in seconds","ref":"Bolt.Sips.Types.DateTimeWithTZOffset.html#create/2","title":"Bolt.Sips.Types.DateTimeWithTZOffset.create/2","type":"function"},{"doc":"Convert DateTimeWithTZOffset struct in a cypher-compliant string","ref":"Bolt.Sips.Types.DateTimeWithTZOffset.html#format_param/1","title":"Bolt.Sips.Types.DateTimeWithTZOffset.format_param/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Types.DateTimeWithTZOffset.html#t:t/0","title":"Bolt.Sips.Types.DateTimeWithTZOffset.t/0","type":"type"},{"doc":"a Duration type, as introduced in bolt V2. Composed of months, days, seconds and nanoseconds, it can be used in date operations","ref":"Bolt.Sips.Types.Duration.html","title":"Bolt.Sips.Types.Duration","type":"module"},{"doc":"Create a Duration struct from data returned by Neo4j. Neo4j returns a list of 4 integers: months days seconds nanoseconds Struct elements are computed in a logical way, then for exmple 65 seconds is 1min and 5 seconds. Beware that you may not retrieve the same data you send! Note: days are not touched as they are not a fixed number of days for each month. Example: iex&gt; Duration.create(15, 53, 125, 54) %Bolt.Sips.Types.Duration{ days: 53, hours: 0, minutes: 2, months: 3, nanoseconds: 54, seconds: 5, weeks: 0, years: 1 }","ref":"Bolt.Sips.Types.Duration.html#create/4","title":"Bolt.Sips.Types.Duration.create/4","type":"function"},{"doc":"Convert a %Duration in a cypher-compliant string. To know everything about duration format, please see: https://neo4j.com/docs/cypher-manual/current/syntax/temporal/#cypher-temporal-durations","ref":"Bolt.Sips.Types.Duration.html#format_param/1","title":"Bolt.Sips.Types.Duration.format_param/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Types.Duration.html#t:t/0","title":"Bolt.Sips.Types.Duration.t/0","type":"type"},{"doc":"base structure for Node and Relationship","ref":"Bolt.Sips.Types.Entity.html","title":"Bolt.Sips.Types.Entity","type":"module"},{"doc":"Self-contained graph node. A Node represents a node from a Neo4j graph and consists of a unique identifier (within the scope of its origin graph), a list of labels and a map of properties. https://github.com/boltprotocol/boltprotocol/blob/master/v1/_serialization.asciidoc#node","ref":"Bolt.Sips.Types.Node.html","title":"Bolt.Sips.Types.Node","type":"module"},{"doc":"Self-contained graph path. A Path is a sequence of alternating nodes and relationships corresponding to a walk in the graph. The path always begins and ends with a node. Its representation consists of a list of distinct nodes, a list of distinct relationships and a sequence of integers describing the path traversal https://github.com/boltprotocol/boltprotocol/blob/master/v1/_serialization.asciidoc#path","ref":"Bolt.Sips.Types.Path.html","title":"Bolt.Sips.Types.Path","type":"module"},{"doc":"represents a traversal or walk through a graph and maintains a direction separate from that of any relationships traversed","ref":"Bolt.Sips.Types.Path.html#graph/1","title":"Bolt.Sips.Types.Path.graph/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Types.Path.html#t:t/0","title":"Bolt.Sips.Types.Path.t/0","type":"type"},{"doc":"Manage spatial data introduced in Bolt V2 Point can be: Cartesian 2D Geographic 2D Cartesian 3D Geographic 3D","ref":"Bolt.Sips.Types.Point.html","title":"Bolt.Sips.Types.Point","type":"module"},{"doc":"A 2D point either needs: 2 coordinates and a atom (:cartesian or :wgs_84) to define its type 2 coordinates and a srid (4326 or 7203) to define its type Examples: iex&gt; Point.create(:cartesian, 10, 20.0) %Bolt.Sips.Types.Point{ crs: &quot;cartesian&quot;, height: nil, latitude: nil, longitude: nil, srid: 7203, x: 10.0, y: 20.0, z: nil } iex&gt; Point.create(4326, 10, 20.0) %Bolt.Sips.Types.Point{ crs: &quot;wgs-84&quot;, height: nil, latitude: 20.0, longitude: 10.0, srid: 4326, x: 10.0, y: 20.0, z: 30.0 }","ref":"Bolt.Sips.Types.Point.html#create/3","title":"Bolt.Sips.Types.Point.create/3","type":"function"},{"doc":"Create a 3D point A 3D point either needs: 3 coordinates and a atom (:cartesian or :wgs_84) to define its type 3 coordinates and a srid (4979 or 9147) to define its type Examples: iex&gt; Point.create(:cartesian, 10, 20.0, 30) %Bolt.Sips.Types.Point{ crs: &quot;cartesian-3d&quot;, height: nil, latitude: nil, longitude: nil, srid: 9157, x: 10.0, y: 20.0, z: 30.0 } iex&gt; Point.create(4979, 10, 20.0, 30) %Bolt.Sips.Types.Point{ crs: &quot;wgs-84-3d&quot;, height: 30.0, latitude: 20.0, longitude: 10.0, srid: 4979, x: 10.0, y: 20.0, z: 30.0 }","ref":"Bolt.Sips.Types.Point.html#create/4","title":"Bolt.Sips.Types.Point.create/4","type":"function"},{"doc":"Convert a Point struct into a cypher-compliant map Example iex(8)&gt; Point.create(4326, 10, 20.0) |&gt; Point.format_to_param %{crs: &quot;wgs-84&quot;, latitude: 20.0, longitude: 10.0, x: 10.0, y: 20.0}","ref":"Bolt.Sips.Types.Point.html#format_param/1","title":"Bolt.Sips.Types.Point.format_param/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Types.Point.html#t:t/0","title":"Bolt.Sips.Types.Point.t/0","type":"type"},{"doc":"Self-contained graph relationship. A Relationship represents a relationship from a Neo4j graph and consists of a unique identifier (within the scope of its origin graph), identifiers for the start and end nodes of that relationship, a type and a map of properties. https://github.com/boltprotocol/boltprotocol/blob/master/v1/_serialization.asciidoc#relationship","ref":"Bolt.Sips.Types.Relationship.html","title":"Bolt.Sips.Types.Relationship","type":"module"},{"doc":"Manage a Time and its time zone offset. This temporal types hs been added in bolt v2","ref":"Bolt.Sips.Types.TimeWithTZOffset.html","title":"Bolt.Sips.Types.TimeWithTZOffset","type":"module"},{"doc":"Create a valid TimeWithTZOffset from a Time and offset in seconds","ref":"Bolt.Sips.Types.TimeWithTZOffset.html#create/2","title":"Bolt.Sips.Types.TimeWithTZOffset.create/2","type":"function"},{"doc":"Convert TimeWithTZOffset struct in a cypher-compliant string","ref":"Bolt.Sips.Types.TimeWithTZOffset.html#format_param/1","title":"Bolt.Sips.Types.TimeWithTZOffset.format_param/1","type":"function"},{"doc":"","ref":"Bolt.Sips.Types.TimeWithTZOffset.html#t:t/0","title":"Bolt.Sips.Types.TimeWithTZOffset.t/0","type":"type"},{"doc":"Self-contained graph relationship without endpoints. An UnboundRelationship represents a relationship relative to a separately known start point and end point. https://github.com/boltprotocol/boltprotocol/blob/master/v1/_serialization.asciidoc#unboundrelationship","ref":"Bolt.Sips.Types.UnboundRelationship.html","title":"Bolt.Sips.Types.UnboundRelationship","type":"module"},{"doc":"","ref":"Bolt.Sips.TypesHelper.html","title":"Bolt.Sips.TypesHelper","type":"module"},{"doc":"Convert NaiveDateTime and timezone into a Calendar.DateTime Without losing micorsecond data!","ref":"Bolt.Sips.TypesHelper.html#datetime_with_micro/2","title":"Bolt.Sips.TypesHelper.datetime_with_micro/2","type":"function"},{"doc":"Decompose an amount seconds into the tuple {hours, minutes, seconds}","ref":"Bolt.Sips.TypesHelper.html#decompose_in_hms/1","title":"Bolt.Sips.TypesHelper.decompose_in_hms/1","type":"function"},{"doc":"Convert an amount of seconds in a +hours:minutes offset","ref":"Bolt.Sips.TypesHelper.html#formated_time_offset/1","title":"Bolt.Sips.TypesHelper.formated_time_offset/1","type":"function"},{"doc":"Quickly run Cypher commands from a mix task Command line options --url, -u - Neo4j server URL --ssl, -s - use ssl The command line options have lower precedence than the options specified in your mix.exs file, if defined. Examples: MIX_ENV=test mix bolt.cypher &quot;MATCH (people:Person) RETURN people.name LIMIT 5&quot; Output sample: &quot;MATCH (people:Person) RETURN people.name as name LIMIT 5&quot; [%{&quot;name&quot; =&gt; &quot;Keanu Reeves&quot;}, %{&quot;name&quot; =&gt; &quot;Carrie-Anne Moss&quot;}, %{&quot;name&quot; =&gt; &quot;Andy Wachowski&quot;}, %{&quot;name&quot; =&gt; &quot;Lana Wachowski&quot;}, %{&quot;name&quot; =&gt; &quot;Joel Silver&quot;}]","ref":"Mix.Tasks.Bolt.Cypher.html","title":"Mix.Tasks.Bolt.Cypher","type":"task"},{"doc":"This module defines a Bolt.Sips.Exception structure containing two fields: code - the error code message - the error details","ref":"Bolt.Sips.Exception.html","title":"Bolt.Sips.Exception","type":"exception"},{"doc":"","ref":"Bolt.Sips.Exception.html#t:t/0","title":"Bolt.Sips.Exception.t/0","type":"type"},{"doc":"Neo4j driver for Elixir. Bolt.Sips is an Elixir driver for Neo4j, providing many useful features: using the Bolt protocol, the Elixir implementation - the Neo4j&#39;s newest network protocol, designed for high-performance; latest Bolt versions, are supported. Can connect to a standalone Neo4j server (:direct mode) or to a Neo4j causal cluster, using the bolt+routing or the newer neo4j schemes; connecting in :routing mode. Provides the user with the ability to create and manage distinct ad-hoc role-based connections to one or more Neo4j servers/databases Supports transactions, simple and complex Cypher queries with or w/o parameters Multi-tenancy Supports Neo4j versions: 3.0.x/3.1.x/3.2.x/3.4.x/3.5.x","ref":"readme.html","title":"Neo4j driver for Elixir.","type":"extras"},{"doc":"Installation Getting Started Basic usage Configuration Direct mode Routing Role-based connections Multi tenancy Using Cypher Temporal and spatial types Transactions Encoding Routing, in detail Multi tenancy, in detail Using Bolt.Sips with Phoenix More examples Installation Available in Hex, the package can be added to your list of dependencies, in the: mix.exs: def deps do [{:bolt_sips, &quot;~&gt; 2.0&quot;}] end Basic usage Provided you have access to a running Neo4j server, and a project where you just added the :bolt_sips dependency, run an iex session inside the project&#39;s folder, and once inside the shell, follow this simple step-by-step example. Start an iex session: Erlang/OTP 21 [erts-10.2.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:1] [hipe] Interactive Elixir (1.8.1) - press Ctrl+C to exit (type h() ENTER for help) iex» {:ok, _neo} = Bolt.Sips.start_link(url: &quot;bolt://neo4j:test@localhost&quot;) {:ok, #PID&lt;0.237.0&gt;} iex» conn = Bolt.Sips.conn() #PID&lt;0.242.0&gt; iex» Bolt.Sips.query!(conn, &quot;return 1 as n&quot;) |&gt; ...» Bolt.Sips.Response.first() %{&quot;n&quot; =&gt; 1} Please see the docs for more examples and details about this driver. Testing You&#39;ll need a running Neo4j server, for running the tests. Please verify that you do not store critical data on this server, as its contents will be wiped clean when the tests are running. If you have docker available on your system, you can start an instance before running the test suite: docker run --rm -p 7687:7687 -e &#39;NEO4J_AUTH=neo4j/test&#39; neo4j:3.0.6 Neo4j versions used for test: 3.0, 3.1, 3.4, 3.5 mix test For the stubs using boltkit, you will have to install Python 3.7 and run: pip install boltkit. After this you can run any tests tagged with :boltkit. Example: mix test test/boltkit_test.exs --include boltkit or: mix test --only boltkit Special thanks Michael Schaefermeyer (@mschae), for the initial version of the Bolt protocol in Elixir: mschae/boltex Contributors As reported by Github: contributions to master, excluding merge commits Contributing Fork it Create your feature branch (git checkout -b my-new-feature) Test (mix test) Commit your changes (git commit -am &#39;Add some feature&#39;) Push to the branch (git push origin my-new-feature) Create new Pull Request License Copyright 2016-2020 the original author or authors Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#table-of-contents","title":"Neo4j driver for Elixir. - Table of Contents","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"fix #83. More details in commit: https://github.com/florinpatrascu/bolt_sips/commit/ebe17e62ab1d823e301b11d99d532663b0b25135 Thank you @kristofka!","ref":"changelog.html#2-0-5","title":"Changelog - 2.0.5","type":"extras"},{"doc":"feature: support connection options in queries PR #82. Many thanks @tcrossland, for this contribution! This PR adds support for passing options through to DBConnection.execute/4 fix some broken links, in the docs; closes #76 update some dependencies, including the DBConnection package. squashing some compile warnings; to be continued /attn: @team ;) please use Elixir 1.9 or 1.10, for test and development - where possible.","ref":"changelog.html#2-0-4","title":"Changelog - 2.0.4","type":"extras"},{"doc":"refactoring the internals for achieving a better performance, while improving the code readability and extensibility - many thanks to @kristofka and @dominique-vassard. You guys are awesome! fix: Consistent bad connection state after malformed query [...] issue #78","ref":"changelog.html#2-0-3","title":"Changelog - 2.0.3","type":"extras"},{"doc":"The 2.0, stable release. Thank you all for your feedback and for contributing to making this driver better. w⦿‿⦿t! fix: Simple Query taking too much time to process #73","ref":"changelog.html#2-0-2","title":"Changelog - === 2.0.2 ===","type":"extras"},{"doc":"swapping the assets around, for better organizing the docs","ref":"changelog.html#2-0-0-rc-2","title":"Changelog - 2.0.0-rc.2","type":"extras"},{"doc":"more documentation fix the TravisCi build min versions erlang 21.2 elixir 1.7","ref":"changelog.html#2-0-0-rc-1","title":"Changelog - 2.0.0-rc.1","type":"extras"},{"doc":"","ref":"changelog.html#2-0-0-rc","title":"Changelog - === 2.0.0-rc ===","type":"extras"},{"doc":"bolt+routing:// is now supported Read more what this schema is, as defined by the Neo4j team Role-based connections Until this version, Bolt.Sips was used for connecting to a single Neo4j server, aka: the &quot;direct&quot; mode. Basically you configure the driver with a url to a Neo4j server and Bolt.Sips will use that to attach itself to it, using a single configuration, remaining attached to that server until it is restarted (or reconfigured). In direct mode, bolt_sips &quot;knows&quot; only one server. Starting with this version you can have as many distinct connection configurations, each of them dedicated to different Neo4j servers, as/if needed. We call these connections: &quot;role-based connections&quot;. For example, when you&#39;ll connect to a Neo4j cluster using the new protocol, i.e. by using a configuration like this: config :bolt_sips, Bolt, # default port considered to be: 7687 url: &quot;bolt+routing://localhost&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10 Bolt.Sips will automatically create three pools of size 10, with the following reserved names: :read, :write and :route. Now you can specify what type of connection you want to use, by its name (role). For example: wconn = Bolt.Sips.conn(:write) ... = Bolt.Sips.query!(wconn, &quot;CREATE (a:Person {name:&#39;Bob&#39;})&quot;) rconn = Bolt.Sips.conn(:read) ... = Bolt.Sips.query!(rconn, &quot;MATCH (a:Person {name: &#39;Bob&#39;}) RETURN a.name AS name&quot;) The roles above: :read, :write and :route, are reserved. Please do not name custom connections using the same names (atoms). And as you just realized, yes: now you can create as many Bolt.Sips direct &quot;driver instances&quot; as you want, or as many as your app/hardware supports. Please see the documentation for much more details. Main breaking changes introduced in version 2.x the hostname config parameter is a string; used to be a charlist the url config parameter must start with a valid schema i.e. bolt, bolt+routing or neo4j. Examples: url: &quot;bolt://localhost&quot; url: &quot;bolt+routing://neo4j:password@neo01.graph.example.com:123456?policy=europe&quot; Bolt.Sips.Query, will return a Bolt.Sips.Response now; it used to be a simple data structure.","ref":"changelog.html#whats-new","title":"Changelog - What&#39;s New?","type":"extras"},{"doc":"","ref":"changelog.html#1-5","title":"Changelog - === 1.5 ===","type":"extras"},{"doc":"add a test alias for running the tests compatible with the most recent Neo4j server while disabling the older/legacy ones cleanup some warning about unused aliases","ref":"changelog.html#1-5-1","title":"Changelog - 1.5.1","type":"extras"},{"doc":"Bolt V3 support Decompose tests by bolt version Important note about transaction","ref":"changelog.html#1-5-0","title":"Changelog - 1.5.0","type":"extras"},{"doc":"Encoding / Decoding types is now at the lowest possible level Decompose encoders / decoders by bolt version Expose only public API in docs","ref":"changelog.html#1-4-0","title":"Changelog - 1.4.0","type":"extras"},{"doc":"1.3.0 stable release. Many thanks to Dominique VASSARD, for his awesome contributions.","ref":"changelog.html#1-3-0","title":"Changelog - 1.3.0","type":"extras"},{"doc":"Fix some typos add json encoding capability","ref":"changelog.html#1-3-0-rc2","title":"Changelog - 1.3.0-rc2","type":"extras"},{"doc":"Bug fix: Nanoseconds formating was erroneous. Example: 54 nanoseconds was formated to &quot;PT0.54S&quot; instead of &quot;PT0.000000054S&quot; Bug fix: Large amount of nanoseconds (&gt;= 1_000_000) wasn&#39;t treated and lead to Neo4j errors. Now large amount of nanoseconds are converted in seconds, with the remainder in nanoseconds.","ref":"changelog.html#1-2-2-rc2","title":"Changelog - 1.2.2-rc2","type":"extras"},{"doc":"Bug fix: If a property contains a speciifc types (date, datetime, point, etc.), it wasn&#39;t decoded. see: https://github.com/florinpatrascu/bolt_sips/issues/55","ref":"changelog.html#1-2-1-rc2","title":"Changelog - 1.2.1-rc2","type":"extras"},{"doc":"support for the spatial and temporal types.","ref":"changelog.html#1-2-0-rc2","title":"Changelog - 1.2.0-rc2","type":"extras"},{"doc":"removed the boltex dependency and added all its &quot;low-level&quot; code to internals.","ref":"changelog.html#1-1-0-rc2","title":"Changelog - 1.1.0-rc2","type":"extras"},{"doc":"Breaking changes introduced in version 1.x non-closure based transactions are not supported anymore. This is a change introduced in DBConnection 2.x. Bolt.Sips version tagged v0.5.10 is the last version supporting open transactions. the support for ETLS was dropped. It was mostly used for development or hand-crafted deployments This version is using the official DBConnection 2.0.0-rc2, from hex.pm","ref":"changelog.html#1-0-0-rc2","title":"Changelog - 1.0.0-rc2","type":"extras"},{"doc":"update the links referencing the Bolt protocol documentation (types, etc)","ref":"changelog.html#0-5-10","title":"Changelog - 0.5.10","type":"extras"},{"doc":"upgrade dependencies trading carefully around the new db_connection, as we&#39;re chasing the code from master currently, and there more changes in the pipe to come for the both projects; db_connection, and this one, respectively.","ref":"changelog.html#0-5-9","title":"Changelog - 0.5.9","type":"extras"},{"doc":"dealing with negative integers see issue #42, for more details","ref":"changelog.html#0-5-8","title":"Changelog - 0.5.8","type":"extras"},{"doc":"elixir 1.6 and code formatting, of course :) minor test updates update dependencies pending code for the newest db_connection (currently using db_connection from the master branch)","ref":"changelog.html#0-5-7","title":"Changelog - 0.5.7","type":"extras"},{"doc":"using the DBConnection, thanks to the work done by Dmitriy Nesteryuk.","ref":"changelog.html#0-5-5","title":"Changelog - 0.5.5","type":"extras"},{"doc":"using Elixir 1.5 not using the ConCache anymore. I initially intended to use its support throughout the driver, but it is not needed. README updated with a short snippet from a Phoenix web app demo, showing how to start Bolt.Sips, as a worker dependencies update minor code cleanup, to prep the code for receiving HA and Bolt routing capabilities","ref":"changelog.html#0-4-11","title":"Changelog - 0.4.11","type":"extras"},{"doc":"better error messages; issue #33 not retrying a connection when the server is not available/started incorrect number of retries, performed by the driver in case of errors; was one extra","ref":"changelog.html#v0-3-5","title":"Changelog - v0.3.5","type":"extras"},{"doc":"dependencies update, minor code cleanup, listening to Credo :) and finally using a Markdown linter","ref":"changelog.html#v0-3-4","title":"Changelog - v0.3.4","type":"extras"},{"doc":"Add link to travis build; #31 by vic","ref":"changelog.html#v0-3-3","title":"Changelog - v0.3.3","type":"extras"},{"doc":"Use the project&#39;s own configuration file when executing the bolt.cypher mix task. Fixes issue #20","ref":"changelog.html#v0-3-2","title":"Changelog - v0.3.2","type":"extras"},{"doc":"rollback/refactor to optionally allow external configuration options to be defined at runtime. You must start the Bolt.Sips manually, when needed, i.e. Bolt.Sips.start_link(url: &quot;localhost&quot;), or by changing your app&#39;s mix config file, i.e. def application do [applications: [:logger, :bolt_sips], mod: {Bolt.Sips.Application, []}] end You can also specify custom configuration settings in you app&#39;s mix config file. These may overwrite your config file: def application do [extra_applications: [:logger], mod: {Bolt.Sips.Application, [url: &#39;localhost&#39;, pool_size: 15]} ] end code cleanup","ref":"changelog.html#v0-3-1-breaking-changes","title":"Changelog - v0.3.1 Breaking changes","type":"extras"},{"doc":"cleanup, and minor dependencies update","ref":"changelog.html#v0-2-6-2017-04-21","title":"Changelog - v0.2.6 (2017-04-21)","type":"extras"},{"doc":"split multi-line Cypher statements containing semicolons only if the ; character is at the end of the line, followed by \\r\\n on Windows and \\n on Unix like system, otherwise it may break the Cypher statement when the semicolon appears somewhere else","ref":"changelog.html#v0-2-5-2017-03-22","title":"Changelog - v0.2.5 (2017-03-22)","type":"extras"},{"doc":"add the fuzzyurl to the list of apps, for project using Elixir &lt; 1.4 (thank you, @dnesteryuk!)","ref":"changelog.html#v0-2-4-2017-02-26","title":"Changelog - v0.2.4 (2017-02-26)","type":"extras"},{"doc":"improved connection handling","ref":"changelog.html#v0-2-3-2017-02-26","title":"Changelog - v0.2.3 (2017-02-26)","type":"extras"},{"doc":"PR #18; Bring up :boltex and :retry in applications, for Elixir &lt; 1.4 (from: @wli0503, thank you!) PR #19; test for error message on invalid parameter types (from: @vic, thank you!).","ref":"changelog.html#v0-2-2-2017-02-24","title":"Changelog - v0.2.2 (2017-02-24)","type":"extras"},{"doc":"stop retrying a request if the failure is an internal one (driver, or driver dependencies related). update the Boltex driver containing two important bug fixes: one where Boltex will fail when receiving too much data (florinpatrascu/bolt_sips/issues/16) and the other one, an improvement, make Boltex.Error.get_id/1 more resilient for new transports (details here: mschae/boltex/issues/14) changed the pool strategy to :fifo, and its timeout to :infinity, and let the (:gen_server) call timeout expire according to the user&#39;s :timeout configuration parameter added a test unit provided by @adri (thank you), for executing a Cypher query, with large set of parameters","ref":"changelog.html#v0-2-1-2017-02-20","title":"Changelog - v0.2.1 (2017-02-20)","type":"extras"},{"doc":"Elixir 1.4 is now required. Using Boltex 0.2.0 bugfix: invalid Cypher statements will now be properly handled when the request is retried automatically","ref":"changelog.html#v0-2-0-breaking-changes","title":"Changelog - v0.2.0 Breaking changes","type":"extras"},{"doc":"With a larger amount of parameters it seems like generating chunks isn&#39;t working correctly. This is a patch imported from Boltex, see: https://github.com/mschae/boltex/issues/13, for more info","ref":"changelog.html#v0-1-11","title":"Changelog - v0.1.11","type":"extras"},{"doc":"accept Map and Struct for query parameters, transparently. Thank you [@wli0503], for the PR.","ref":"changelog.html#v0-1-10-2017-02-11","title":"Changelog - v0.1.10 (2017-02-11)","type":"extras"},{"doc":"Some of the users are encountering difficulties when trying to compile bolt_sips on Windows. This release is addressing their concern. Bolt.Sips will use the optional System variable: BOLT_WITH_ETLS, for depending on the ETLS package. If that variable is not defined, then Bolt.Sips will use the standard Erlang :ssl module, for the SSL/TLS protocol; the default behavior, starting with this version. Therefore, if you want the much faster ssl/tls support offered by ETLS, then use this: export BOLT_WITH_ETLS=true on Linux/OSX, for example. Then: mix deps.get mix test and so on. (Don&#39;t forget to mix deps.unlock --all, if you plan to plan to further debugging/developing w/ or w/o the BOLT_WITH_ETLS support) Many thanks to: Ben Wilson, for advices.","ref":"changelog.html#v0-1-9-2017-01-27","title":"Changelog - v0.1.9 (2017-01-27)","type":"extras"},{"doc":"using Elixir 1.4 add more details to the README, about the components required to build ETLS, the TCP/TLS layer added newer Elixirs to the Travis CI configuration file minor code cleanups","ref":"changelog.html#v0-1-8-2017-01-07","title":"Changelog - v0.1.8 (2017-01-07)","type":"extras"},{"doc":"Connection code refactored for capturing the errors when the remote server is not responding on the first request, or if the driver is misconfigured i.e. wrong port number, bad hostname ... updated the test configuration file with detailed info about the newly introduced option: :retry_linear_backoff, mostly as a reminder","ref":"changelog.html#v0-1-7-2017-01-02","title":"Changelog - v0.1.7 (2017-01-02)","type":"extras"},{"doc":"we&#39;re already using configurable timeouts, when executing requests from the connection pool. But with Bolt, the initial handshake sequence (happening before sending any commands to the server) is represented by two important calls, executed in sequence: handshake and init, and they must both succeed, before sending any (Cypher) requests. You can see the details in the Bolt protocol specs. This sequence is also sensitive to latencies, such as: network latencies, busy servers, etc., and because of that we&#39;re introducing a simple support for retrying the handshake (and the subsequent requests) with a linear backoff, and try the handshake sequence (or the request) a couple of times before giving up - all these as part of the exiting pool management, of course. This retry is configurable via a new configuration parameter, the: :retry_linear_backoff, respectively. For example: config :bolt_sips, Bolt, url: &quot;bolt://Bilbo:Baggins@hobby-hobbits.dbs.graphenedb.com:24786&quot;, ssl: true, timeout: 15_000, retry_linear_backoff: [delay: 150, factor: 2, tries: 3] In the example above the retry will linearly increase the delay from 150ms following a Fibonacci pattern, cap the delay at 15 seconds (the value defined by the :timeout parameter) and giving up after 3 attempts. The same retry mechanism (and configuration parameters) is also honored when we send requests to the neo4j server.","ref":"changelog.html#v0-1-6-2017-01-01","title":"Changelog - v0.1.6 (2017-01-01)","type":"extras"},{"doc":"as requested by many users, this version is introducing the optional url configuration parameter. If present, it will be used for extracting the host name, the port and the authentication details. Please see the README, for a couple of examples. For brevity: config :bolt_sips, Bolt, url: &#39;bolt://demo:demo@hobby-wowsoeasy.dbs.graphenedb.com:24786&#39;, ssl: true","ref":"changelog.html#v0-1-5-2016-12-30","title":"Changelog - v0.1.5 (2016-12-30)","type":"extras"},{"doc":"add support for connecting to Neo4j servers on encrypted sockets. Currently only TLSv1.2 is supported, using the default BoringSSL cipher; via :etls. To connect securely to a remote Neo4j server, such as the ones provided by graphenedb.com, modify your Bolt.Sips config file like this (example): config :bolt_sips, Bolt, hostname: &#39;bolt://hobby-blah.dbs.graphenedb.com&#39;, basic_auth: [username: &quot;wow&quot;, password: &quot;of_course_this_is_the_password&quot;], port: 24786, pool_size: 5, ssl: true, max_overflow: 1 Observe the new flag: ssl: true Please note this is work in progress","ref":"changelog.html#v0-1-4-merry-christmas","title":"Changelog - v0.1.4 (Merry Christmas)","type":"extras"},{"doc":"integrate the Boltex code from https://github.com/mschae/boltex, and let the Bolt.Sips wrapper to manage the connectivity, using a simple Poolboy implementation for connection pooling","ref":"changelog.html#v0-1-2-2016-11-06","title":"Changelog - v0.1.2 (2016-11-06)","type":"extras"},{"doc":"a temporary solution for dealing with negative values while extracting a graph walk-through from a Path. Dealing with this in Boltex instead, but this fix should work for now.","ref":"changelog.html#v0-1-1-2016-09-09","title":"Changelog - v0.1.1 (2016-09-09)","type":"extras"},{"doc":"First release!","ref":"changelog.html#v0-1-0-2016-08-31","title":"Changelog - v0.1.0 (2016-08-31)","type":"extras"},{"doc":"Getting Started Let&#39;s start by creating a simple Elixir project, as a playground for our tests. mix new neo4j_demo --sup --app n4d --module N4D cd neo4j_demo Open the mix.exs and add the bolt_sips dependency. defmodule N4D.MixProject do use Mix.Project def project do [ app: :n4d, version: &quot;0.1.0&quot;, elixir: &quot;~&gt; 1.8&quot;, start_permanent: Mix.env() == :prod, deps: deps() ] end # Run &quot;mix help compile.app&quot; to learn about applications. def application do [ extra_applications: [:logger], mod: {N4D.Application, []} ] end # Run &quot;mix help deps&quot; to learn about dependencies. defp deps do [ {:bolt_sips, &quot;~&gt; 2.0.0-rc&quot;}, {:jason, &quot;~&gt; 1.1&quot;} ] end end we added the jason library too, for converting the server responses to json. And then run: mix do deps.get, compile","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"And our simple project is ready for us to start experimenting with it. Let&#39;s first configure the connection to a running Neo4j server. We presume a standalone community edition server is started and available on the localhost interface, and having its Bolt port open at: 7687. For simplicity edit the config/config.exs, and modify it to look like this: use Mix.Config config :bolt_sips, Bolt, url: &quot;bolt://localhost:7687&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10 With the project configured to connect to a Neo4j server, in direct mode, we can add Bolt.Sips to the app&#39;s main supervision tree, and let the OTP manage it. # lib/n4_d/application.ex defmodule N4D.Application do @moduledoc false use Application def start(_type, _args) do children = [ {Bolt.Sips, Application.get_env(:bolt_sips, Bolt)} ] opts = [strategy: :one_for_one, name: N4D.Supervisor] Supervisor.start_link(children, opts) end end There are a couple of different other ways to start the driver but let&#39;s keep it simple for now. The easiest way to start playing with the driver, in the current configuration, is to drop into the IEx shell and run simple Cypher commands through it. cd neo4j_demo iex -S mix","ref":"getting-started.html#starting-the-driver","title":"Getting Started - Starting the driver","type":"extras"},{"doc":"A few examples: iex» alias Bolt.Sips, as: Neo iex» alias Bolt.Sips.Response # check the driver is up and running: iex» Neo.info() %{ default: %{ connections: %{direct: %{&quot;localhost:7687&quot; =&gt; 0}, routing_query: nil}, user_options: [ socket: Bolt.Sips.Socket, port: 7687, url: &quot;bolt://localhost:7687&quot;, # ... basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10 ] } } # in direct mode, our current configuration, all the operations such as: read/write or # delete, are sent to the Neo4j server using a common connection (pool). # Let&#39;s obtain a connection: iex» conn = Neo.conn() #PID&lt;0.308.0&gt; # a few examples: iex» response = Neo.query!(conn, &quot;CREATE (p:Person)-[:LIKES]-&gt;(t:Technology)&quot;) %Response{ bookmark: nil, fields: [], notifications: [], plan: nil, profile: nil, records: [], results: [], stats: %{ &quot;labels-added&quot; =&gt; 2, &quot;nodes-created&quot; =&gt; 2, &quot;relationships-created&quot; =&gt; 1 }, type: &quot;w&quot; } # query with undirected relationship unless sure of direction %Bolt.Sips.Response{results: results} = response = Neo.query!(conn, &quot;MATCH (p:Person)-[:LIKES]-(t:Technology) RETURN p&quot;) # where `results` contain: [%{&quot;p&quot; =&gt; %Bolt.Sips.Types.Node{id: 355, labels: [&quot;Person&quot;], properties: %{}}}] # and we can also encode them to json, as simple as this: iex» Jason.encode!(results) &quot;[{\\&quot;p\\&quot;:{\\&quot;id\\&quot;:355,\\&quot;labels\\&quot;:[\\&quot;Person\\&quot;],\\&quot;properties\\&quot;:{}}}]&quot; # of course you can do more: iex» Bolt.Sips.query!(Bolt.Sips.conn(), &quot;RETURN [10,11,21] AS arr&quot;, %{}, timeout: 19_000) |&gt; ...» Enum.reduce(0, &amp;(Enum.sum(&amp;1[&quot;arr&quot;]) + &amp;2)) 42 # see more examples and the tests, for getting familiar with what is possible. # Enjoy! Follow this link: Cypher Basics, for a gentle introduction to Cypher; Neo4j&#39;s query language. Throughout the code snippets we are often using examples copied from the original documentation published by Neo4j, so that you can feel comfortable with them.","ref":"getting-started.html#usage","title":"Getting Started - Usage","type":"extras"},{"doc":"Configuration Bolt.Sips can be configured using the well known Mix config files, or by using simple keyword lists. This is the most basic configuration: config :bolt_sips, Bolt, url: &quot;bolt://localhost:7687&quot; It tells Bolt.Sips your Neo4j server is available locally, and it listens on port 7687, expecting bolt commands. These are the values you can configure, and their default values: :url- a full url to pointing to a running Neo4j server. Please remember you must specify the scheme used to connect to the server. Valid schemes:bolt,bolt+routingandneo4j - the last two being used for connecting to a Neo4j causal cluster. :pool_size - the size of the connection pool. Default: 15 :timeout - a connection timeout value defined in milliseconds. Default: 15_000 :ssl-true, if the connection must be encrypted. Default:false :prefix- used for differentiating between multiple connections available in the same app. Default::default","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"Connecting to remote (hosted) Neo4j servers, such as the ones available (also for free) at Neo4j/Sandbox: config :bolt_sips, Bolt, url: &quot;bolt://&lt;ip_address&gt;:&lt;bolt_port&gt;&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;#######&quot;] ssl: true","ref":"configuration.html#examples-of-configurations","title":"Configuration - Examples of configurations","type":"extras"},{"doc":"Until this version, Bolt.Sips was used for connecting to a single Neo4j server from the moment the hosting app started, until the hosting app was terminated/restarted. This is known as the: direct mode. In direct mode, the Bolt.Sips driver has one configuration describing the connection to a single Neo4j server. Since this connection mode is well known to our users, we&#39;ll not spend time on talking about it. It is sufficient to say that in direct mode, you have one configurable pool of connections, and the settings governing them i.e. timeout, size, etc., are all about this single connection. Because starting with version 2.0 Bolt.Sips is supporting a new type of connectivity: routing, for connecting to multiple servers or to a Neo4j causal cluster, you must specify the scheme in the url parameter, of your configuration. Example, for configuring a connection in direct mode: url: &quot;bolt://localhost:7687&quot; We&#39;ll spend more ink on talking about the routing mode, next.","ref":"configuration.html#direct-mode","title":"Configuration - Direct mode","type":"extras"},{"doc":"With the 2.0 version, Bolt.Sips is implementing the ability to connect your app to a Neo4j causal cluster. You can read more about this, here: Neo4j Causal Clustering The features of using a causal cluster, in Neo4j&#39;s own words: Neo4j’s Causal Clustering provides three main features: Safety: Core Servers provide a fault tolerant platform for transaction processing which will remain available while a simple majority of those Core Servers are functioning. Scale: Read Replicas provide a massively scalable platform for graph queries that enables very large graph workloads to be executed in a widely distributed topology. Causal consistency: when invoked, a client application is guaranteed to read at least its own writes. To configure Bolt.Sips for connecting to a Neo4j Causal Cluster, you only need the specify the appropriate scheme, in the url configuration parameter: url: &quot;bolt+routing://localhost:7687&quot; or: url: &quot;neo4j://localhost:7687&quot; Prefer the latter, since bolt+routing appears to be soon deprecated, by Neo4j. We&#39;ll use neo4j:// throughout the docs for referring to the routing mode, for brevity. Read more about routing, here.","ref":"configuration.html#routing-mode","title":"Configuration - Routing mode","type":"extras"},{"doc":"When we implemented the routing mode, we realized we could extend this ability to letting you define any number of connections, identified by a role name of your choice. For example, say your default configuration for Bolt.Sips looks like this: config :bolt_sips, Bolt, url: &quot;bolt://localhost:7687&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10, max_overflow: 2, Bolt.Sips will load it by default, when your application starts. And with a configuration like that, the default mode, you will continue to obtain connections using the default Bolt.Sips.conn() function. However, if you require to have different connections, say: to a different Neo4j server that has some specific role, you could add a new configuration, for example: config :bolt_sips, :hidden_gems, url: &quot;bolt://localhost:1234&quot;, pool_size: 50, role: :hidden_gems You&#39;d have to load this config separately, after the starting the Bolt.Sipsdriver. Like this: iex» Bolt.Sips.start_link(Application.get_env(:bolt_sips, :hidden_gems)) {:ok, #PID&lt;0.266.0&gt;} and the you can use connections from this new configuration, as easy as this: iex» conn = Bolt.Sips.conn(:hidden_gems) #PID&lt;0.324.0&gt; while for obtaing the connections from your default configuration, is business as usual: iex» conn = Bolt.Sips.conn() #PID&lt;0.309.0&gt; The new connection pool is supervised by the main Bolt.Sips.ConnectionSupervisor, you don&#39;t have to do anythings special for that. In the final release, we&#39;ll add a friendlier api for adding role-based connections. More details about role-based-connections, here","ref":"configuration.html#role-based-connections","title":"Configuration - Role based connections","type":"extras"},{"doc":"Another important feature of the 2.0 version, is: multi-tenancy. Starting with this version, your app can connect to any number of Neo4j servers, in direct mode or routing. We introduced a new configurable parameter, named: prefix. At this time, the only way to configure the driver for multi-tenancy, is programmatically, not via the configuration file. Example: my_secret_cluster_config [ url: &quot;neo4j://localhost:9001&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10, max_overflow: 2, queue_interval: 500, queue_target: 1500, prefix: :secret_cluster ] {:ok, _pid} = Bolt.Sips.start_link(@routing_connection_config) conn = Bolt.Sips.conn(:write, prefix: :secret_cluster) And you can start as many connections as needed, for as long as the :prefix has different names. These connections can be used for connecting to the same or different Neo4j servers. More details about multi-tenancy, here","ref":"configuration.html#multi-tenancy","title":"Configuration - Multi tenancy","type":"extras"},{"doc":"Using Bolt.Sips to query the Neo4j server Let&#39;s talk about the basics of querying a Neo4j server, using Bolt.Sips, and a few methods you could use for using the data returned by the server, using the Bolt.Sips.Response. You can learn so much more from the official docs, available at Neo4j, you should start from there, if you want to get a deep understanding about the Neo4j graph database and its query language: Cypher.","ref":"using-cypher.html","title":"Using Bolt.Sips to query the Neo4j server","type":"extras"},{"doc":"a Neo4j server running locally and available at this url: bolt://neo4j:test@localhost a mix project with :bolt_sips available","ref":"using-cypher.html#what-you-need","title":"Using Bolt.Sips to query the Neo4j server - What you need?","type":"extras"},{"doc":"With the above prerequisites, let&#39;s drop into the IEx shell and start experimenting. cd my_neo4j iex -S mix Erlang/OTP 21 [erts-10.2.3] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:1] [hipe] Interactive Elixir (1.8.1) - press Ctrl+C to exit (type h() ENTER for help) iex» First we need to start the driver with a minimalist configuration (unless it is already started by your project?): iex» {:ok, _neo} = Bolt.Sips.start_link(url: &quot;bolt://neo4j:test@localhost&quot;) {:ok, #PID&lt;0.243.0&gt;} iex» Presuming your database is empty, you can still test your setup by running a simple Cypher query: iex» conn = Bolt.Sips.conn() #PID&lt;0.248.0&gt; iex» Bolt.Sips.query!(conn, &quot;RETURN 1 as n&quot;) |&gt; ...» Bolt.Sips.Response.first() %{&quot;n&quot; =&gt; 1} and we obtained our first response from the server: %{&quot;n&quot; =&gt; 1}, w⦿‿⦿t!! Now let&#39;s try some more complicated Cypher queries. We&#39;ll use examples that you may want to paste them in your .exs/.ex files rather than into the IEx shell, for readability. While most of the Cypher querier fit on a simple row, and they look compact, you might encounter situations where you need to send multiple queries in a single trip, to the server. Bolt.Sips allows you do that. Let&#39;s initialize our test database with some data. cypher = &quot;&quot;&quot; CREATE (BoltSips:BoltSips {title:&#39;Elixir sipping from Neo4j, using Bolt&#39;, released:2016, license:&#39;MIT&#39;, bolt_sips: true}) CREATE (TNOTW:Book {title:&#39;The Name of the Wind&#39;, released:2007, genre:&#39;fantasy&#39;, bolt_sips: true}) CREATE (Patrick:Person {name:&#39;Patrick Rothfuss&#39;, bolt_sips: true}) CREATE (Kvothe:Person {name:&#39;Kote&#39;, bolt_sips: true}) CREATE (Denna:Person {name:&#39;Denna&#39;, bolt_sips: true}) CREATE (Chandrian:Deamon {name:&#39;Chandrian&#39;, bolt_sips: true}) CREATE (Kvothe)-[:ACTED_IN {roles:[&#39;sword fighter&#39;, &#39;magician&#39;, &#39;musician&#39;]}]-&gt;(TNOTW), (Denna)-[:ACTED_IN {roles:[&#39;many talents&#39;]}]-&gt;(TNOTW), (Chandrian)-[:ACTED_IN {roles:[&#39;killer&#39;]}]-&gt;(TNOTW), (Patrick)-[:WROTE]-&gt;(TNOTW) &quot;&quot;&quot; {:ok, response} = Bolt.Sips.conn() |&gt; Bolt.Sips.query(cypher) According to the response from the server, this is what we did: iex» response %Bolt.Sips.Response{ results: [], stats: %{ &quot;labels-added&quot; =&gt; 6, &quot;nodes-created&quot; =&gt; 6, &quot;properties-set&quot; =&gt; 19, &quot;relationships-created&quot; =&gt; 4 }, type: &quot;w&quot; } we have 6 new Nodes, 6 new labels and 4 new relationships. At any time, if you want to clean up the data we&#39;re creating, you can use this query: MATCH (n {bolt_sips: true}) OPTIONAL MATCH (n)-[r]-() DELETE n,r Observe we&#39;re adding a bolt_sips property to the Nodes we&#39;re adding, so that it&#39;s easier to refer them in our tests. Let&#39;s see how many nodes of &quot;type&quot; (label, according to Cypher&#39;s official terminology) Person having the property bolt_sips true, we have in our database: iex» query = &quot;&quot;&quot; ...» MATCH (n:Person {bolt_sips: true}) ...» RETURN n.name AS Name ...» ORDER BY Name DESC ...» LIMIT 5 ...» &quot;&quot;&quot; iex» %Bolt.Sips.Response{} = response = Bolt.Sips.query!(conn, query) %Bolt.Sips.Response{ bookmark: &quot;neo4j:bookmark:v1:tx21613&quot;, fields: [&quot;Name&quot;], notifications: [], plan: nil, profile: nil, records: [[&quot;Patrick Rothfuss&quot;], [&quot;Kote&quot;], [&quot;Denna&quot;]], results: [ %{&quot;Name&quot; =&gt; &quot;Patrick Rothfuss&quot;}, %{&quot;Name&quot; =&gt; &quot;Kote&quot;}, %{&quot;Name&quot; =&gt; &quot;Denna&quot;} ], stats: [], type: &quot;r&quot; } We have 3 of them, and we&#39;re only showing the name property! Above you see the full Bolt.Sips.Response returned by our driver based on the raw data returned by the Neo4j server. The :results key, contains the aggregated response you will use most of the time, and for that the Bolt.Sips.Response module has some useful helpers, for example: iex» response |&gt; ...» Bolt.Sips.Response.first() %{&quot;Name&quot; =&gt; &quot;Patrick Rothfuss&quot;} and much more. Check the Bolt.Sips.Response&#39;s own docs, for more.","ref":"using-cypher.html#simple-queries-using-cypher","title":"Using Bolt.Sips to query the Neo4j server - Simple queries, using Cypher","type":"extras"},{"doc":"Using temporal and spatial types Temporal and spatial types are supported since Neo4J 3.4. You can used the elixir structs: Time, NaiveDateTime, DateTime, as well as the Bolt Sips structs: DateTimeWithTZOffset, TimeWithTZOffset, Duration, Point. $ MIX_ENV=test iex -S mix Erlang/OTP 21 [erts-10.0.5] [source] [64-bit] [smp:8:8] [ds:8:8:10] [async-threads:1] [hipe] Interactive Elixir (1.7.3) - press Ctrl+C to exit (type h() ENTER for help) iex&gt; alias Bolt.Sips.Types.{Duration, DateTimeWithTZOffset, Point, TimeWithTZOffset} [Bolt.Sips.Types.Duration, Bolt.Sips.Types.DateTimeWithTZOffset, Bolt.Sips.Types.Point, Bolt.Sips.Types.TimeWithTZOffset] iex&gt; alias Bolt.Sips.TypesHelper Bolt.Sips.TypesHelper iex&gt; {:ok, pid} = Bolt.Sips.start_link(url: &quot;localhost&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;]) {:ok, #PID&lt;0.236.0&gt;} iex&gt; conn = Bolt.Sips.conn :bolt_sips_pool # Date without timezone with Date iex(8)&gt; Bolt.Sips.query!(conn, &quot;RETURN date({d}) AS d&quot;, %{d: ~D[2019-02-04]}) [%{&quot;d&quot; =&gt; ~D[2019-02-04]}] # Time without timezone with Time iex&gt; Bolt.Sips.query!(conn, &quot;RETURN localtime({t}) AS t&quot;, %{t: ~T[13:26:08.543440]}) [%{&quot;t&quot; =&gt; ~T[13:26:08.543440]}] # Datetime without timezone with Naive DateTime iex&gt; Bolt.Sips.query!(conn, &quot;RETURN localdatetime({ldt}) AS ldt&quot;, %{ldt: ~N[2016-05-24 13:26:08.543]}) [%{&quot;ldt&quot; =&gt; ~N[2016-05-24 13:26:08.543]}] # Datetime with timezone ID with DateTime (through Calendar) iex&gt; date_time_with_tz_id = TypesHelper.datetime_with_micro(~N[2016-05-24 13:26:08.543], &quot;Europe/Paris&quot;) #DateTime&lt;2016-05-24 13:26:08.543+02:00 CEST Europe/Paris&gt; iex&gt; Bolt.Sips.query!(conn, &quot;RETURN datetime({dt}) AS dt&quot;, %{dt: date_time_with_tz_id}) [%{&quot;dt&quot; =&gt; #DateTime&lt;2016-05-24 13:26:08.543+02:00 CEST Europe/Paris&gt;}] # Datetime with timezone offset (seconds) with DateTimeWithTZOffset iex(17)&gt; date_time_with_tz = DateTimeWithTZOffset.create(~N[2016-05-24 13:26:08.543], 7200) %Bolt.Sips.Types.DateTimeWithTZOffset{ naive_datetime: ~N[2016-05-24 13:26:08.543], timezone_offset: 7200 } iex(18)&gt; Bolt.Sips.query!(conn, &quot;RETURN datetime({dt}) AS dt&quot;, %{dt: date_time_with_tz}) [ %{ &quot;dt&quot; =&gt; %Bolt.Sips.Types.DateTimeWithTZOffset{ naive_datetime: ~N[2016-05-24 13:26:08.543], timezone_offset: 7200 } } ] # Datetime with timezone offset (seconds) with TimeWithTZOffset iex&gt; time_with_tz = TimeWithTZOffset.create(~T[12:45:30.250000], 3600) %Bolt.Sips.Types.TimeWithTZOffset{ time: ~T[12:45:30.250000], timezone_offset: 3600 } iex&gt; Bolt.Sips.query!(conn, &quot;RETURN time({t}) AS t&quot;, %{t: time_with_tz}) [ %{ &quot;t&quot; =&gt; %Bolt.Sips.Types.TimeWithTZOffset{ time: ~T[12:45:30.250000], timezone_offset: 3600 } } ] # Cartesian 2D point with Point iex&gt; point_cartesian_2D = Point.create(:cartesian, 50, 60.5) %Bolt.Sips.Types.Point{ crs: &quot;cartesian&quot;, height: nil, latitude: nil, longitude: nil, srid: 7203, x: 50.0, y: 60.5, z: nil } iex&gt; Bolt.Sips.query!(conn, &quot;RETURN point({pt}) AS pt&quot;, %{pt: point_cartesian_2D}) [ %{ &quot;pt&quot; =&gt; %Bolt.Sips.Types.Point{ crs: &quot;cartesian&quot;, height: nil, latitude: nil, longitude: nil, srid: 7203, x: 50.0, y: 60.5, z: nil } } ] # Geographic 2D point with Point iex&gt; point_geo_2D = Point.create(:wgs_84, 50, 60.5) %Bolt.Sips.Types.Point{ crs: &quot;wgs-84&quot;, height: nil, latitude: 60.5, longitude: 50.0, srid: 4326, x: 50.0, y: 60.5, z: nil } iex&gt; Bolt.Sips.query!(conn, &quot;RETURN point({pt}) AS pt&quot;, %{pt: point_geo_2D}) [ %{ &quot;pt&quot; =&gt; %Bolt.Sips.Types.Point{ crs: &quot;wgs-84&quot;, height: nil, latitude: 60.5, longitude: 50.0, srid: 4326, x: 50.0, y: 60.5, z: nil } } ] # Cartesian 3D point with Point iex&gt; point_cartesian_3D = Point.create(:cartesian, 50, 60.5, 12.34) %Bolt.Sips.Types.Point{ crs: &quot;cartesian-3d&quot;, height: nil, latitude: nil, longitude: nil, srid: 9157, x: 50.0, y: 60.5, z: 12.34 } iex&gt; Bolt.Sips.query!(conn, &quot;RETURN point({pt}) AS pt&quot;, %{pt: point_cartesian_3D}) [ %{ &quot;pt&quot; =&gt; %Bolt.Sips.Types.Point{ crs: &quot;cartesian-3d&quot;, height: nil, latitude: nil, longitude: nil, srid: 9157, x: 50.0, y: 60.5, z: 12.34 } } ] # Geographic 2D point with Point iex&gt; point_geo_3D = Point.create(:wgs_84, 50, 60.5, 12.34) %Bolt.Sips.Types.Point{ crs: &quot;wgs-84-3d&quot;, height: 12.34, latitude: 60.5, longitude: 50.0, srid: 4979, x: 50.0, y: 60.5, z: 12.34 } iex&gt; Bolt.Sips.query!(conn, &quot;RETURN point({pt}) AS pt&quot;, %{pt: point_geo_2D}) [ %{ &quot;pt&quot; =&gt; %Bolt.Sips.Types.Point{ crs: &quot;wgs-84&quot;, height: nil, latitude: 60.5, longitude: 50.0, srid: 4326, x: 50.0, y: 60.5, z: nil } } ]","ref":"using-temporal-and-spatial-types.html","title":"Using temporal and spatial types","type":"extras"},{"doc":"About transactions Transaction management in Neo4j 3.5+ differs from what it was in prior versions. The cypher keyword BEGIN, COMMIT and ROLLBACK are no longer available. In order to have a query that runs fine in all versions, you should use the following pattern: # Commit is performed automatically if everythings went fine conn = Bolt.Sips.conn() Bolt.Sips.transaction(conn, fn conn -&gt; result = Bolt.Sips.query!(conn, &quot;CREATE (m:Movie {title: &quot;Matrix&quot;}) RETURN m&quot;) end) # Rollback is performed automatically in case of error Bolt.Sips.transaction(conn, fn conn -&gt; result =Bolt.Sips.query!(conn, &quot;Invalid query&quot;) end) # Rollback can stil be forced Bolt.Sips.transaction(conn, fn conn -&gt; result = Bolt.Sips.query!(conn, &quot;CREATE (m:Movie {title: &quot;Matrix&quot;}) RETURN m&quot;) Bolt.Sips.rollback(conn, :dont_save) end)","ref":"about-transactions.html","title":"About transactions","type":"extras"},{"doc":"About encoding Bolt.Sips provides support for encoding your query result in different formats. For now, only JSON is supported. There is two way of encoding data to json: By using the helpers provided by the module Bolt.Sips.ResponseEncoder Using your usual JSON encoding library. Bolt.Sips have implementation for: Jason and Poison. With this the query results can be automatically encoded by one of the libraries available: Jason or Poison. No further work is required when using a framework like: Phoenix, for example. A few examples around the encoding suport: iex&gt; query_result = [ %{ &quot;t&quot; =&gt; %Bolt.Sips.Types.Node{ id: 26, labels: [&quot;Test&quot;], properties: %{ &quot;created_at&quot; =&gt; &quot;2019-08-03T12:34:56+01:00&quot;, &quot;name&quot; =&gt; &quot;A test node&quot;, &quot;uid&quot; =&gt; 12345 } } } ] # Using Bolt.Sips.ResponseEncoder iex&gt; Bolt.Sips.ResponseEncoder.encode(query_result, :json) {:ok, &quot;[{\\&quot;t\\&quot;:{\\&quot;id\\&quot;:26,\\&quot;labels\\&quot;:[\\&quot;Test\\&quot;],\\&quot;properties\\&quot;:{\\&quot;created_at\\&quot;:\\&quot;2019-08-03T12:34:56+01:00\\&quot;,\\&quot;name\\&quot;:\\&quot;A test node\\&quot;,\\&quot;uid\\&quot;:12345}}}]&quot;} iex(11)&gt; Bolt.Sips.ResponseEncoder.encode!(query_result, :json) &quot;[{\\&quot;t\\&quot;:{\\&quot;id\\&quot;:26,\\&quot;labels\\&quot;:[\\&quot;Test\\&quot;],\\&quot;properties\\&quot;:{\\&quot;created_at\\&quot;:\\&quot;2019-08-03T12:34:56+01:00\\&quot;,\\&quot;name\\&quot;:\\&quot;A test node\\&quot;,\\&quot;uid\\&quot;:12345}}}]&quot; # Using Jason iex(14)&gt; Jason.encode!(query_result) &quot;[{\\&quot;t\\&quot;:{\\&quot;id\\&quot;:26,\\&quot;labels\\&quot;:[\\&quot;Test\\&quot;],\\&quot;properties\\&quot;:{\\&quot;created_at\\&quot;:\\&quot;2019-08-03T12:34:56+01:00\\&quot;,\\&quot;name\\&quot;:\\&quot;A test node\\&quot;,\\&quot;uid\\&quot;:12345}}}]&quot; # Using Poison iex(13)&gt; Poison.encode!(query_result) &quot;[{\\&quot;t\\&quot;:{\\&quot;properties\\&quot;:{\\&quot;uid\\&quot;:12345,\\&quot;name\\&quot;:\\&quot;A test node\\&quot;,\\&quot;created_at\\&quot;:\\&quot;2019-08-03T12:34:56+01:00\\&quot;},\\&quot;labels\\&quot;:[\\&quot;Test\\&quot;],\\&quot;id\\&quot;:26}}]&quot; Both solutions rely on protocols, then they can be easily overridden if needed. More info in the modules Bolt.Sips.ResponseEncoder.Json, Bolt.Sips.ResponseEncoder.Json.Jason, Bolt.Sips.ResponseEncoder.Json.Poison","ref":"about-encoding.html","title":"About encoding","type":"extras"},{"doc":"Routing When connecting to a Neo4j cluster, Bolt.Sips will create 3 distinct connection pools, each of them dedicated to one of the following connection types (connection roles): :route - used for getting information from the Neo4j router, such as: routing details about which server is handling what type of role: read/write, and more. :read - used for read-only connections :write - used for write-only connections. Having the Bolt.Sips configured in routing mode, will enforce your code to clarify what type of connections you want, type you must specify when requesting a Bolt.Sips connection. Example: rconn = Bolt.Sips.conn(:read) wconn = Bolt.Sips.conn(:write) router_conn = Bolt.Sips.conn(:route) Without being explicit about the connection type, you will receive errors, in case you&#39;ll attempt to execute a query that will say: create new nodes, on a server having the role: read or route. This is the only rule you must observe, when using the Bolt.Sips driver with a causal cluster.","ref":"routing.html","title":"Routing","type":"extras"},{"doc":"Let&#39;s walk-through a simple experiment with using Bolt.Sips in routing mode and a Neo4j cluster. If you don&#39;t have a local server, or a remote Neo4j cluster available for your tests, you can easily setup your own local playground. All you need is Docker. We&#39;ll use a docker-compose.yml file that you can find in the Bolt.Sips main source repo. If you have: Docker installed, and running. You can get Docker from here: https://docs.docker.com/installation/ and a simple Elixir project having the :bolt_sips driver installer, as a dependency Start the Neo4j cluster In a folder where you have the docker-compose.yml file, start a new shell session and run the following command: docker-compose up If this is the first time you run this command, or use Neo4j as a Docker image, then based on the quality of your Internet connection, you&#39;ll wait a few seconds while Docker downloads a Neo4j Enterprise image. You&#39;ll see something like this: Creating network &quot;neo4j_lan&quot; with the default driver Pulling core1 (neo4j:3.5.3-enterprise)... 3.5.3-enterprise: Pulling from library/neo4j e7c96db7181b: Pull complete f910a506b6cb: Pull complete b6abafe80f63: Pull complete b95a7fd32595: Pull complete 6c09128ad074: Pull complete 648805e5f471: Pull complete e2790f69a70d: Pull complete Creating core2 ... done Creating core3 ... done Creating core1 ... done Attaching to core3, core1, core2 core3 | Changed password for user &#39;neo4j&#39;. core1 | Changed password for user &#39;neo4j&#39;. core2 | Changed password for user &#39;neo4j&#39;. core3 | Active database: graph.db core3 | Directories in use: core3 | home: /var/lib/neo4j core3 | config: /var/lib/neo4j/conf ... and towards the end of the starting sequence, this: core2 | 2019-06-17 12:37:59.078+0000 INFO Remote interface available at http://localhost:7475/ core3 | 2019-06-17 12:37:59.165+0000 INFO Remote interface available at http://localhost:7476/ Check to see if you can connect to your local Neo4j cluster, as simple as pointing your Internet browser to this url: http://localhost:7474, and if everything was executed successfully, you&#39;ll be seeing the familiar Neo4j web interface. Now let&#39;s play with the Bolt.Sipsdriver and our local Neo4j cluster. Change your elixir test project configuration and modify the config/config.exs file like this (excerpt): use Mix.Config config :bolt_sips, Bolt, # bolt+routing will be deprecated?! # url: &quot;bolt+routing://localhost:7687&quot;, url: &quot;neo4j://localhost:7687&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;test&quot;], pool_size: 10 then start a IEx shell session, from the projects&#39;r main folder: iex -S mix. While inside the IEx session, let&#39;s see if our configuration is sound? iex» Bolt.Sips.info() %{ default: %{ connections: %{ read: %{&quot;localhost:7688&quot; =&gt; 0, &quot;localhost:7689&quot; =&gt; 0}, route: %{ &quot;localhost:7687&quot; =&gt; 0, &quot;localhost:7688&quot; =&gt; 0, &quot;localhost:7689&quot; =&gt; 0 }, write: %{&quot;localhost:7687&quot; =&gt; 0}, routing_query: %{...}, ttl: 300, updated_at: 1560775628 }, user_options: [ url: &quot;neo4j://localhost:7687&quot;, pool_size: 10, .... ] } } if you see the response above, it means your settings are ready. Without going into much details about the data structure above, the routing details are these: read: %{&quot;localhost:7688&quot; =&gt; 0, &quot;localhost:7689&quot; =&gt; 0}, write: %{&quot;localhost:7687&quot; =&gt; 0}, route: %{ &quot;localhost:7687&quot; =&gt; 0, &quot;localhost:7688&quot; =&gt; 0, &quot;localhost:7689&quot; =&gt; 0 ttl: 300, updated_at: ... According to the routing information returned by our cluster, we have: two nodes accepting :read commands: localhost:7688 andlocalhost:7689 three nodes capabale of responding with routing specific details: localhost:7687 localhost:7688 and localhost:7689 one node accepting :write commands; the localhost:7687, respectively. But don&#39;t worry about the gory details, we got you covered :) Let&#39;s run some Cypher queries. iex» alias Bolt.Sips.Response iex» alias Bolt.Sips, as: Neo # obtaining a read(only) connection: iex» rconn = Neo.conn(:read) #PID&lt;0.324.0&gt; # checking if there are any Person nodes &quot;named&quot;: Bob? iex» %Response{results: r} = Neo.query!(rconn, &quot;MATCH (p:Person{name: &#39;Bob&#39;}) RETURN p&quot;) %Bolt.Sips.Response{ bookmark: &quot;neo4j:bookmark:v1:tx2&quot;, fields: [&quot;p&quot;], notifications: [], plan: nil, profile: nil, records: [], results: [], stats: [], type: &quot;r&quot; } # r is [], meaning: our query found none. So let&#39;s create one. # First we obtain a connection suitable for `write` operations: iex» wconn = Neo.conn(:write) #PID&lt;0.384.0&gt; # and now we can use it for creating a new node: iex» %Response{results: r} = Neo.query!(wconn, &quot;CREATE (p:Person{name:&#39;Bob&#39;})&quot;) %Bolt.Sips.Response{ ... stats: %{&quot;labels-added&quot; =&gt; 1, &quot;nodes-created&quot; =&gt; 1, &quot;properties-set&quot; =&gt; 1}, type: &quot;w&quot; } # our node was created and has one property set, w⦿‿⦿t! # but can we find it? Rerun the previous query using the `read` connection: iex» Neo.query!(rconn, &quot;MATCH (p:Person{name: &#39;Bob&#39;}) RETURN p&quot;) |&gt; Response.first() %{ &quot;p&quot; =&gt; %Bolt.Sips.Types.Node{ id: 20, labels: [&quot;Person&quot;], properties: %{&quot;name&quot; =&gt; &quot;Bob&quot;} } } # and yessss, our new Person node is in the cluster! # Do you need its json form, instead? Easy: iex» Neo.query!(rconn, &quot;MATCH (p:Person{name: &#39;Bob&#39;}) RETURN p&quot;) |&gt; ...» Response.first() |&gt; ...» Bolt.Sips.ResponseEncoder.encode!(:json) &quot;{\\&quot;p\\&quot;:{\\&quot;id\\&quot;:20,\\&quot;labels\\&quot;:[\\&quot;Person\\&quot;],\\&quot;properties\\&quot;:{\\&quot;name\\&quot;:\\&quot;Bob\\&quot;}}}&quot; But what happens if we try to create a new Person, using our read connection? iex» Neo.query!(rconn, &quot;CREATE (p:Person{name:&#39;Alice&#39;})&quot;) ** (Bolt.Sips.Exception) ... No write operations are allowed directly on this database. Writes must pass through the leader. The role of this server is: FOLLOWER Neo4j will promptly let us know we can&#39;t use that connection for write operations. This is the main difference that you must consider when coding. Same command executed on the proper (write) connection, will be successful: iex» Neo.query!(wconn, &quot;CREATE (p:Person{name:&#39;Alice&#39;})&quot;) %Bolt.Sips.Response{ ... stats: %{&quot;labels-added&quot; =&gt; 1, &quot;nodes-created&quot; =&gt; 1, &quot;properties-set&quot; =&gt; 1}, type: &quot;w&quot; }","ref":"routing.html#routing-walk-through","title":"Routing - Routing walk-through","type":"extras"},{"doc":"Multi tenancy Very similar to the role-based connections, with multi-tenancy you will be able to connect to servers where the type of the server (role) is defined by the server itself, such as the Neo4j causal cluster. This setting is sill in its infancy, it works, but you&#39;ll have to be careful when using it. For differentiating about Neo4j tenants, we introduced a new configurations parameter, named: :prefix. Example: monster_cluster_conf = [ url: &quot;neo4j://localhost&quot;, basic_auth: [username: &quot;neo4j&quot;, password: &quot;password&quot;], pool_size: 50, prefix: :monster_cluster baby_monster_cluster_conf = [ url: &quot;neo4j://raspberry_π&quot;, basic_auth: [username: &quot;πs&quot;, password: &quot;4VR&quot;], pool_size: 50, prefix: :baby_monster_cluster In the example above we defined two different connections, each of them pointing to different Neo4j clusters. As you know now, every cluster will have role-specific connections as defined by the routers, in those clusters. The connection roles will be: :write, :read and :route. To specify what connection you want and on what server, you will use the :prefix optional parameter of the new Bolt.Sips.conn/2 method. Example: Bolt.Sips.conn(:read, prefix: :monster_cluster) |&gt; Bolt.Sips.query!(&quot;MATCH (n) RETURN n.name AS name&quot;) or: Bolt.Sips.conn(:read, prefix: :baby_monster_cluster) |&gt; Bolt.Sips.query!(&quot;MATCH (n) RETURN n.name AS name&quot;) (wip)","ref":"multi-tenancy.html","title":"Multi tenancy","type":"extras"},{"doc":"Using Bolt.Sips with Phoenix, or similar Don&#39;t forget to start the Bolt.Sips driver in your supervision tree. Example: defmodule MoviesElixirPhoenix do use Application # See https://hexdocs.pm/elixir/Application.html # for more information on OTP Applications def start(_type, _args) do # Define workers and child supervisors to be supervised children = [ # Start the endpoint when the application starts {Bolt.Sips, Application.get_env(:bolt_sips, Bolt)}, %{ id: MoviesElixirPhoenix.Endpoint, start: {MoviesElixirPhoenix.Endpoint, :start_link, []} } ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [strategy: :one_for_one, name: MoviesElixirPhoenix.Supervisor] Supervisor.start_link(children, opts) end # Tell Phoenix to update the endpoint configuration # whenever the application is updated. def config_change(changed, _new, removed) do MoviesElixirPhoenix.Endpoint.config_change(changed, removed) :ok end end The code above was extracted from the Neo4j Movies Demo, a Phoenix web application using this driver and the well known Dataset - Movie Database. Note: as explained below, you don&#39;t need to convert your query result before having it encoded in JSON. BoltSips provides Jason and Poison implementation to tackle this problem automatically.","ref":"using-with-phoenix.html","title":"Using Bolt.Sips with Phoenix, or similar","type":"extras"}]